#include <stdarg.h>
#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <ctype.h>

#define word unsigned int
#define dword unsigned long
#define ulong unsigned long
#define byte unsigned char
#define NO_MATCH                    0x0
#define EXACT_MATCH                 0x1
#define MATCH_WITH_ADDED_EXTENSION  0x2

void clrkb (void)
{ while (kbhit()) getch(); }

void donothing(void){}

// Create Long Word sized Patterns
void CreatePattern(unsigned long far *DestBlk, unsigned long NumOfLongWrds,unsigned int Pattern)
{ unsigned long Cntr=0;
  switch (Pattern)
   { case 0: // Begin Clear Pattern
      while(Cntr++ < NumOfLongWrds) *DestBlk++ = 0;
     break; // End Clear Pattern
     case 1: // Begin Count Pattern
      while(Cntr < NumOfLongWrds)   *DestBlk++ = Cntr++;
      break; // End Count Pattern
     case 2: // Count Pattern in High And Low Word
      while(Cntr < NumOfLongWrds)
       { *DestBlk++ = (Cntr << 16) + Cntr;
         Cntr++;
       }
      break;
  // Case three : 00000000's, 55555555's, AAAAAAAA's, FFFFFFFF's
  //              Count Pattern High And Low Word,
     case 3: // Begin Four way Pattern
      { int Patrn = 0;
        unsigned int CntPat = 0;
        while(Cntr < NumOfLongWrds)
         { switch(Patrn)
            { case 0: *DestBlk = 0x0; break;
              case 1: *DestBlk = 0x55555555; break;
              case 2: *DestBlk = 0xAAAAAAAA; break;
              case 3: *DestBlk = 0xFFFFFFFF; break;
              case 4: *DestBlk = ((unsigned long)CntPat+1 << 16) + (unsigned long)CntPat;
               CntPat+=2;
              break;
            }
           Patrn++;
           if (Patrn > 4) Patrn = 0;
           Cntr++;
           DestBlk++;
         }
        break;
     } // End Four way Pattern
   }
}

// Create Word sized Patterns
void CreatePattern(unsigned int far *DestBlk, unsigned int NumOfWrds,int Pattern)
{  unsigned int Cntr=0;
   switch (Pattern)
      {
      case 0: // Begin Clear Pattern
         while(Cntr++ < NumOfWrds)
            *DestBlk++ = 0;
         break; // End Clear Pattern

      case 1: // Begin Count Pattern
         while(Cntr < NumOfWrds)
            *DestBlk++ = Cntr++;
         break; // End Count Pattern

      case 2: // Count Pattern in High And Low Word
         while(Cntr < NumOfWrds)
            {
            *DestBlk++ = (Cntr << 8) + Cntr;
            Cntr++;
            }
         break;
   // Case three : 0000's, 5555's, AAAA's, FFFF's
   //              Count Pattern High And Low Word,
      case 3: // Begin Four way Pattern
         {
         int Patrn = 0;
         unsigned char CntPat = 0;
         while(Cntr < NumOfWrds)
            {
            switch(Patrn)
               {
               case 0:
                  *DestBlk = 0x0;
                  break;
               case 1:
                  *DestBlk = 0x5555;
                  break;
               case 2:
                  *DestBlk = 0xAAAA;
                  break;
               case 3:
                  *DestBlk = 0xFFFF;
                  break;
               case 4:
                  *DestBlk = ((unsigned long)CntPat+1 << 8) + (unsigned long)CntPat;
                  CntPat+=2;
                  CntPat &= 0xF;
                  break;
               }
            Patrn++;
            if (Patrn > 4)
               Patrn = 0;
            Cntr++;
            DestBlk++;
            }
         break;
         } // End Four way Pattern
      }
}


// Create Byte sized Patterns
void CreatePattern(unsigned char far *DestBlk, unsigned int NumOfbytes,int Pattern)
{ unsigned int Cntr=0;
   switch (Pattern)
      {
      case 0: // Begin Clear Pattern
         while(Cntr++ < NumOfbytes)
            *DestBlk++ = 0;
         break; // End Clear Pattern

      case 1: // Begin Count Pattern
         while(Cntr < NumOfbytes)
            *DestBlk++ = Cntr++;
         break; // End Count Pattern

      case 2: // Count Pattern in High And Low Word
         while(Cntr < NumOfbytes)
            {
            *DestBlk++ = (Cntr << 4) + Cntr;
            Cntr++;
            }
         break;
   // Case three : 0000's, 5555's, AAAA's, FFFF's
   //              Count Pattern High And Low Word,
      case 3: // Begin Four way Pattern
         {
         int Patrn = 0;
         unsigned char CntPat = 0;
         while(Cntr < NumOfbytes)
            {
            switch(Patrn)
               {
               case 0:
                  *DestBlk = 0x0;
                  break;
               case 1:
                  *DestBlk = 0x5555;
                  break;
               case 2:
                  *DestBlk = 0xAAAA;
                  break;
               case 3:
                  *DestBlk = 0xFFFF;
                  break;
               case 4:
                  *DestBlk = ((unsigned long)CntPat+1 << 4) + (unsigned long)CntPat;
                  CntPat+=2;
                  break;
               }
            Patrn++;
            if (Patrn > 4)
               Patrn = 0;
            Cntr++;
            DestBlk++;
            }
         break;
         } // End Four way Pattern
      }
}

void ViewBuffer(unsigned long far *Source, unsigned int NumOfLongWrds,
                int ViewMethod,int UprLtX,int UprLtY)
{
   switch(ViewMethod)
      {
      case 1: // View Vertically
         {
         while(NumOfLongWrds-- > 0)
            {
            gotoxy(UprLtX,UprLtY++);
            cprintf("%08lX",*Source++);
            }
         break;
         }
      case 2: // View Horizontally
         gotoxy(UprLtX,UprLtY);
         while(NumOfLongWrds-- > 0)
            cprintf("%08lX ",*Source++);
         break;
      }
}

void ViewBuffer(unsigned int far *Source, unsigned int NumOfWrds,
                int ViewMethod,int UprLtX,int UprLtY)
{
   switch(ViewMethod)
      {
      case 1: // View Vertically
         {
         while(NumOfWrds-- > 0)
            {
            gotoxy(UprLtX,UprLtY++);
            cprintf("%04X",*Source++);
            }
         break;
         }
      case 2: // View Horizontally
         gotoxy(UprLtX,UprLtY);
         while(NumOfWrds-- > 0)
            cprintf("%04X ",*Source++);
         break;
      }
}

void ViewBuffer(unsigned char far *Source, unsigned int NumOfBytes,
                int ViewMethod,int UprLtX,int UprLtY)

{
   switch(ViewMethod)
      {
      case 1: // View Vertically
         {
         while(NumOfBytes-- > 0)
            {
            gotoxy(UprLtX,UprLtY++);
            cprintf("%02X",*Source++);
            }
         break;
         }
      case 2: // View Horizontally
         gotoxy(UprLtX,UprLtY);
         while(NumOfBytes-- > 0)
            cprintf("%02X ",*Source++);
         break;
      }
}

void LogScreen(int first_line, int last_line, FILE *logF)
{ int i, j, screen[25][80];
  if (first_line > last_line)
   { i = first_line;
     first_line = last_line;
     last_line = i;
   }
  if ((first_line < 1) || (last_line > 25))
   { first_line = 1;
     last_line = 25;
   }
  gettext(1, 1, 80, 25, screen);
  for (i = first_line - 1; i < last_line; i++)
   { //for (j=0;j<80;j++)
     fprintf(logF,"%s",screen[i]);
//      fputc(screen[i][j], logF); //don't put EOF char
     fprintf(logF,"\n");
   }
}

struct Screen
{ char HotKeyName[50];
  unsigned long HotKeyValue;
  void (*action)();
  char *Line;
}; //struct Screen

class MenuList
{
   public:
      MenuList(Screen *HotKeyValuesProceduresMenu);
      void Display(int UprLtX=1, int UprLtY=1, int Verically=1);
      void Active(int Beg,int End);
      unsigned long PromptUsr(unsigned long Mask = 0x0000FFFF);

   private:
      Screen *mMenu;
      int mBegActive,mEndActive,mLineCnt;
}; // class MenuList

MenuList::MenuList(Screen *HotKeyValuesProceduresMenu)
{
   mMenu = HotKeyValuesProceduresMenu;
   mLineCnt = 0;
} //MenuList::MenuList(Screen *HotKeyValuesProceduresMenu)

void MenuList::Active(int Beg,int End)
{
   Beg--;
   End--;
   if (Beg > End) { int Tmp = Beg; Beg = End; End = Tmp; } //Beg>End?Swap:Nothing

   mBegActive = ((Beg > 0) & (Beg < 25)) ? Beg:0;
   mEndActive = ((End < 25) & (End > 0)) ? End:25;
} //void MenuList::Active(int Beg,int End)

void MenuList::Display(int UprLtX, int UprLtY, int Verically)
{  gotoxy(UprLtX,UprLtY);
   int CurX = UprLtX;
   int CurY = UprLtY;
   mLineCnt=0;
   do {if ((CurX + strlen(mMenu[mBegActive+mLineCnt].HotKeyName) +
                   strlen(mMenu[mBegActive+mLineCnt].Line)) > 79)
            { CurX = UprLtX; CurY++; }
       gotoxy(CurX,CurY);
       cprintf("%s%s",mMenu[mBegActive+mLineCnt].HotKeyName,
                      mMenu[mBegActive+mLineCnt].Line);
       if (Verically) CurY++;
       else { CurX += (strlen(mMenu[mBegActive+mLineCnt].HotKeyName) +
                       strlen(mMenu[mBegActive+mLineCnt].Line)); }
      }while(mLineCnt++ < (mEndActive - mBegActive));
} //void MenuList::Display(int UprLtX, int UprLtY)

unsigned long MenuList::PromptUsr(unsigned long Mask)
{
//Definition of the Returned Value (32 bits)
// The Mask is Used to ignore certain bits so it is possible to ignore
//    certain combinations
//           example:   MENU_f1   0x0000103B with num lock off
//                      MENU_f1   0x0020103B with num lock on
//                      Mask      0x0000FFFF
//                    F1 pressed  0x0000103B Value Looked for in routine
//                    F1 pressed  0x0000103B Value Returned with num lock off
//                    F1 pressed  0x0020103B Value Returned with num lock on
//    The Mask won't Alter the returned value. It will only be of concern
//        within this routine, so that it maycall the appropriate procedure
//        with more ease for the programmer. If this Procedure doesn't call
//        another Procedure then the Mask is up the the Calling Procedure.
//
//
// The Lower 12 bits (0..11) are for the ascii code returned for the pressed key
//            3 bits (12..14) are reserved for Future expansion of routine
//            1 bit  (15)  signal Extended Key. '1' says key is Extended
//
//           bit 16 Right  Shift Pressed
//           bit 17 Left   Shift Pressed
//           bit 18 Ctrl         Pressed
//           bit 19 Alt          Pressed
//
//           bit 20 Scroll Lock  Enabled
//           bit 21 Num    Lock  Enabled
//           bit 22 Caps   Lock  Enabled
//           bit 23 Insert Key   Toggled
//
//           bit 24 SysReq key   Pressed
//           bit 25 Caps   Lock  pressed
//           bit 26 Num    Lock  Pressed
//           bit 27 Scroll lock  Pressed
//
//           bit 28 Right  Alt   Pressed
//           bit 29 Right  Ctrl  Pressed
//           bit 30 Left   Alt   Pressed
//           bit 31 Left   Ctrl  Pressed
//

   clrkb();
   unsigned long ReturnValue = 0;
   unsigned int usr = getch();
   unsigned int KeyCode=0;
   asm{
      mov ah,0x0012
      int 0x16
      mov KeyCode,ax
      }
   if (!usr) { usr = getch(); usr |= 0x1000; }
   ReturnValue = (unsigned long) usr | ((unsigned long)KeyCode << 16);
   mLineCnt = 0;
   do {if (((mMenu[mBegActive+mLineCnt].HotKeyValue) & Mask) == (ReturnValue & Mask))
          (*mMenu[mBegActive+mLineCnt].action)();
      }while(mLineCnt++ < (mEndActive - mBegActive));
   return (ReturnValue);
} // unsigned long PromptUsr(unsigned long Mask = 0x0000FFFF);


unsigned long PromptUsr(unsigned long Mask)
{
//Definition of the Returned Value (32 bits)
//   See Definition for  unsigned long MenuList::PromptUsr(unsigned long Mask)
//   Mask Does modify the returned value in this procedure.

   clrkb();
   unsigned long ReturnValue = 0;
   unsigned int usr = getch();
   unsigned int KeyCode=0;
   asm{
      mov ah,0x0012
      int 0x16
      mov KeyCode,ax
      }
   if (!usr) { usr = getch(); usr |= 0x1000; }
   ReturnValue = ((unsigned long) usr | ((unsigned long)KeyCode << 16)) & Mask;
   return (ReturnValue);
} // unsigned long PromptUsr(unsigned long Mask = 0x0000FFFF);

int GetsWithDefault(char DefaultStr[],char *ReturnStr)
{
   printf("\nGets String Called   :");
   gets(ReturnStr);
   if (strlen(ReturnStr) == 0)
      {
      strcpy(ReturnStr,DefaultStr);
      return(0);  // Signal ReturnStr not Changed
      }
   else return(1); // Add a compare to make sure not to signal when Entered string == default string
}

int GetsWithDefault(char DefaultStr,char *ReturnStr)
{
   *ReturnStr = getch();
   if (*ReturnStr == 0x0D) // 0x0D == Enter
      {
      *ReturnStr = DefaultStr;
      return(0);
      }
   if (*ReturnStr == DefaultStr)
      return(0);
   else
      return(1);
}

unsigned long CompareBuffers(unsigned int far *TxMittedBlk, unsigned int far *RcvdBlk,
                             unsigned int NumberOfWords)
{  unsigned long DifferenceCnt=0;
   for (int cntr=0; cntr < NumberOfWords; cntr++)
      if (TxMittedBlk[cntr] != RcvdBlk[cntr]) DifferenceCnt++;
   return (DifferenceCnt); }

void SignalIndicator(int CurX,int CurY,char Char0,char Char1,char Char2,
                     char Char3,int IndicatorChoice)
{ static LstIndicator=IndicatorChoice;
  static int ThisX=CurX,ThisY=CurY;
  static char Ch0=Char0,Ch1=Char1,Ch2=Char2,Ch3=Char3;
  if (CurX != 0) ThisX=CurX;
  if (CurY != 0) ThisY=CurY;
  CurX=wherex(); CurY=wherey();
  if ((ThisX != 0) | (ThisY != 0)) gotoxy(ThisX,ThisY);
  IndicatorChoice &= 0x3;
  if (!IndicatorChoice)
      { IndicatorChoice = LstIndicator++; IndicatorChoice &= 0x3; }
  switch(IndicatorChoice)
      { case 0: cprintf("%c",Ch0); break;
        case 1: cprintf("%c",Ch1) ; break;
        case 2: cprintf("%c",Ch2) ; break;
        case 3: cprintf("%c",Ch3) ; break; }
  if ((ThisX != 0) | (ThisY != 0)) gotoxy(CurX,CurY); }

void setcursor(int CursurValue)
{ char Mode=0,StartScanLine,EndScanLine,SetCursoValue;
  asm { mov ah,0x0f       // Get mode and Place in al
        int 0x10
        mov Mode,0x0f     // Get mode and Place in al
        mov ah,0x03       // Get Current Cursor Shape and Position
        mov bh,00         //    from Page 0
        int 0x10
        mov StartScanLine,ch
        mov EndScanLine,cl }
   StartScanLine &= 0x1F; EndScanLine   &= 0x1F;
   SetCursoValue = (StartScanLine | CursurValue);
   asm { mov ah,0x01       // Set text mode and Cursor and Shape
         mov al,Mode       // Prevent AMMI bios from locking up
         mov ch,SetCursoValue
         mov cl,EndScanLine
         int 0x10
         mov Mode,al }
}

int VerifyFileExists(char Filename[],char Extension[])
{ struct ffblk FileBlk;
  if (strchr(Filename,'.'))
   { if (findfirst(Filename,&FileBlk,0) == 0)
      return(EXACT_MATCH); }
  else
   {if (findfirst(Filename,&FileBlk,0) == 0)
      return(EXACT_MATCH);
    else { strcat(Filename,Extension);
           if (findfirst(Filename,&FileBlk,0) == 0)
           return(MATCH_WITH_ADDED_EXTENSION); }
   }
   return(NO_MATCH);
}

void printargs(char *msg, ...)
{ va_list ap;
  char far *arg,*IndividualCharPtr;
  cprintf("%s",msg);
  va_start(ap,msg);
  arg = va_arg(ap,char*);
  while((*arg != NULL) && (arg != NULL))
   { IndividualCharPtr = arg;
     while(*IndividualCharPtr != '\0')
      putch(*IndividualCharPtr++);
     arg = va_arg(ap,char*);
   }
  va_end(ap);
}
