#include "stdio.h"
#include "c:\lee\log.h"
#include "c:\lee\screen.h"

#define ulong unsigned long
#define word unsigned int
#define byte unsigned char

#define A16 0
#define A24 1
#define A32 2
#define D16 3
#define D32 4
#define BUS_ERROR 1

byte rd_vme_a16s_d16(ulong, word*);
byte rd_vme_a16s_d32(ulong, ulong*);
byte rd_vme_a24s_d16(ulong, word*);
byte rd_vme_a24s_d32(ulong, ulong*);
byte rd_vme_a32s_d16(ulong, word*);
byte rd_vme_a32s_d32(ulong, ulong*);
byte wr_vme_a16s_d16(ulong, word);
byte wr_vme_a16s_d32(ulong, ulong);
byte wr_vme_a24s_d16(ulong, word);
byte wr_vme_a24s_d32(ulong, ulong);
byte wr_vme_a32s_d16(ulong, word);
byte wr_vme_a32s_d32(ulong, ulong);

void InitVme(ulong Address, word AddressSize);
void ResetVme(void);
extern ulong PrevAddrsSize;

class REGISTER : public LOG
{ public:
	REGISTER(ulong Address,word AddressSize = A16,word DataSize = D16,
            FILE *ReportFile='\0', const char TextToWrite[] = "",
            SCREEN *CurScreen=NULL);
   ~REGISTER();
   ulong TestBits(word TestBits,ulong Nwords=0x10000,word Pattern=1);
   byte ReadRegister(word *Data);
   byte WriteRegister(word Data);
   void Log();
   void InitAccess(void);

   word mAddressSize,mDataSize;
//   word far * mAddrPtr;
   ulong far * mAddrPtr;
   ulong mAddress;
   char mRegName[100];
   SCREEN *mCurScreen;
   FILE *mReportFile;
   // Note:          Name->mAddrPtr will return the value of the address
   //               *Name->mAddrPtr will return the data at that address
};
